<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 15/05/2017
 * Time: 17:30
 */

namespace Repositories;

class ContabilRepository {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getResumosDroByCnpjSupAndDtocorrenciaAndNrorg($nrorg, $cdfilial, $dtocorrencia, $nrtipomoviment)
    {
        try {
            $query = <<<SQL
SELECT
    RD.DTOCORRENCIA,
    EM.CDINTESTRUTEXPFIL,
    RD.CDDESPADMFAT,
    DE.DSDESPADMFAT,
    SUM(RD.VRLANCAMENTO) VRLANCAMENTO,
    SUM(RD.NRQTDEVINC) NRQTDEVINC
  FROM FPA_RESUMODRO RD
  JOIN ESTRUTURAM EMS ON EMS.NRORG = RD.NRORG
                    AND EMS.NRESTRUTURAM = RD.NRESTRUTURAMSUP
  JOIN ESTRUTURAH EHS ON EHS.NRORG = EMS.NRORG
                    AND EHS.NRESTRUTURAM = EMS.NRESTRUTURAM
                    AND EHS.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EHS.NRESTRUTURAM
                                                AND H1.NRORG = EHS.NRORG
                                                AND TO_CHAR(H1.DTMESCOMPETENC,'DD/MM/YYYY') <= :P_DTOCORRENCIA)
  JOIN ESTRUTURAM EM ON EM.NRORG = RD.NRORG
                    AND EM.NRESTRUTURAM = RD.NRESTRUTURAM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND TO_CHAR(H1.DTMESCOMPETENC,'DD/MM/YYYY') <= :P_DTOCORRENCIA)
  JOIN DESPADMFATUR DE ON DE.NRORG = RD.NRORG
                      AND DE.CDDESPADMFAT = RD.CDDESPADMFAT
 WHERE RD.NRORG = :P_NRORG
   AND EM.CDINTESTRUTEXPFIL = :P_CDFILIAL
   AND RD.DTOCORRENCIA = TO_DATE(:P_DTOCORRENCIA,'DD/MM/YYYY')
   AND (RD.NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT OR (:P_NRTIPOMOVIMENT IS NULL AND RD.NRTIPOMOVIMENT IN (1,4)))
 GROUP BY 
    RD.DTOCORRENCIA,
    EM.CDINTESTRUTEXPFIL,
    RD.CDDESPADMFAT,
    DE.DSDESPADMFAT
 ORDER BY 1,2,3
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_CDFILIAL' => $cdfilial,
                'P_DTOCORRENCIA' => $dtocorrencia,
                'P_NRTIPOMOVIMENT' => $nrtipomoviment,
            );

            $resumos = $this->entityManager->getConnection()->fetchAll($query, $params);

            return $resumos;
        } catch (\Exception $e) {
            throw $e;
        }
    }
} 