/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_CONFCARD                          			     			   */
/* Tabela : CONFCARD                                    		      				*/
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CONFCARD'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_CONFCARD
  GO


CREATE TRIGGER DTULTATU_CONFCARD
ON CONFCARD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'CONFCARD', CDFILIAL, 'CDSERVFILI='+ CDSERVFILI +'; NRSEQCNFCARD='+ CONVERT(                                VARCHAR, NRSEQCNFCARD) +';
                               CDFILIAL='+ CDFILIAL +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONFCARD
      SET DTULTATUCFCA = GETDATE()
      FROM INSERTED
      WHERE
         (CONFCARD.CDFILIAL     = INSERTED.CDFILIAL)   AND
         (CONFCARD.CDSERVFILI   = INSERTED.CDSERVFILI) AND
         (CONFCARD.NRSEQCNFCARD = INSERTED.NRSEQCNFCARD)
   END;
END;
GO


